import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Shooter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Automaton  extends Actor
{
    private State previousState;
    private State nextState;
    private int previousParameter;
    private int nextParameter;
    private ShootingProblemWorld world;
    
    public Automaton(State initialState) {
        previousState = initialState;
        nextState = initialState;
    }
    
    public Automaton() {
        this(State.NONE);
    }

    public void addedToWorld(World world) {
        this.world = (ShootingProblemWorld)world;
        setImage(previousState.getImage(this));
    }

    /**
     * Act - do whatever the Shooter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public final void act() 
    {
        if(world.isRulesStage()) {
            System.out.println("Running rules");
            runRules();
        } else {
            System.out.println("Updating state - "+nextState.toString());
            previousState = nextState;
            previousParameter = nextParameter;
            setImage(previousState.getImage(this));
        }
    }   
    
    public abstract void runRules();
    
    public State getState() {
        return previousState;
    }
    
    protected void setState(State state) {
        nextState = state;
    }
    
    public int getParameter() {
        return previousParameter;
    }
    
    protected void setParameter(int parameter) {
        nextParameter = parameter;
    }
    
    protected Automaton getAutomatonLeft() {
        List list = getWorld().getObjectsAt(getX()-1, getY(), Automaton.class);
        if(list.size() == 0) {
            return null;
        } else {
            return (Automaton)list.get(0);
        }
    }
    
    protected Automaton getAutomatonRight() {
        List list = getWorld().getObjectsAt(getX()+1, getY(), Automaton.class);
        if(list.size() == 0) {
            return null;
        } else {
            return (Automaton)list.get(0);
        }
    }
}
