import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;

/**
 * Write a description of class StateHighlighter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class RuleHighlighter  extends Actor
{
    private int offset, height;
    private int origOffset, origHeight;
    private static final int DEFAULT_TTL = 2;
    private int ttl = DEFAULT_TTL;

    public RuleHighlighter(int top, int height) {
        this.offset = top;
        this.origOffset = top;
        this.height = height;
        this.origHeight = height;
    }
    
    public static void addToWorld(int y, int height, World world) {
        int gridY = y / world.getCellSize();
        int top = y % world.getCellSize();
        List rhs = world.getObjectsAt(0, gridY, RuleHighlighter.class);
        if(rhs.size() > 0) {
            for(Object obj: rhs) {
                RuleHighlighter rh = (RuleHighlighter)obj;
                if(rh.origOffset == top && rh.origHeight == height) {
                    // This has already been added
                    rh.ttl = DEFAULT_TTL;
                    return;
                } else {
                    System.out.println(String.format("Top: %d != %d ?", rh.origOffset, top));
                    System.out.println(String.format("Height: %d != %d ?", rh.origHeight, height));
                }
            }
        }
        RuleHighlighter sh = new RuleHighlighter(top, height);
        world.addObject(sh, 0, gridY);
        System.out.println(gridY);
        System.out.println(top);
    }

    public void addedToWorld(World world) {
        int width = world.getWidth()*world.getCellSize();
        int left = width/2;
        int imageHeight = Math.max(offset+height, world.getCellSize());
        if(imageHeight > world.getCellSize()) {
            offset += (imageHeight - world.getCellSize());
            imageHeight += (imageHeight - world.getCellSize());
        }
        GreenfootImage image = new GreenfootImage(width*2, imageHeight);
        //image.drawRect(0, 0, image.getWidth()-1, image.getHeight()-1);
        image.setColor(Color.YELLOW);
        image.fillRect(left, offset, width+left, height);
        //System.out.println(left+", "+offset+", "+(width+left)+", "+(height+offset));
        image.setTransparency(128);
        setImage(image);
    }

    /**
     * Act - do whatever the StateHighlighter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        ttl--;
        if(ttl == 0){
            getWorld().removeObject(this);
        }
    }    
}
