import greenfoot.*;
import java.awt.Color;

/**
 * Write a description of class State here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public enum State  
{
    NONE,
    COMMAND_TO_FIRE {
        public GreenfootImage getImage(Automaton actor) {
            return getColourImage(actor, Color.RED);
        }
    },
    COUNTING_UP {
        public GreenfootImage getImage(Automaton actor) {
            return getColourParameteredImage(actor, Color.YELLOW);
        }
    },
    COUNTING_DOWN {
        public GreenfootImage getImage(Automaton actor) {
            return getColourParameteredImage(actor, Color.BLUE);
        }
    },
    FIRE {
        public GreenfootImage getImage(Automaton actor) {
            return getColourImage(actor, Color.RED);
        }
    },
    DONE {
        public GreenfootImage getImage(Automaton actor) {
            return getColourImage(actor, Color.BLACK);
        }
    },
    ON {
        public GreenfootImage getImage(Automaton actor) {
            return getColourImage(actor, Color.BLACK);
        }
    },
    OFF;
    
    public GreenfootImage getImage(Automaton actor) {
        return getDefaultImage(actor);
    }
    
    protected GreenfootImage getDefaultImage(Automaton actor){
        GreenfootImage image = new GreenfootImage(actor.getWorld().getCellSize(), actor.getWorld().getCellSize());
        image.drawRect(0, 0, image.getWidth()-1, image.getHeight()-1);
        return image;
    }
    
    protected GreenfootImage getColourImage(Automaton actor, Color colour) {
        GreenfootImage image = getDefaultImage(actor);
        image.setColor(colour);
        image.fillRect(1, 1, image.getWidth()-2, image.getHeight()-2);
        return image;
    }
    
    protected GreenfootImage getColourParameteredImage(Automaton actor, Color colour) {
        GreenfootImage image = getDefaultImage(actor);
        image.setColor(colour);
        image.fillRect(1, 1, image.getWidth()-2, image.getHeight()-2);
        image.setColor(Color.BLACK);
        image.drawString(String.valueOf(actor.getParameter()), 0, image.getHeight());
        return image;
    }
}
